#define FILE_NAME "Example1.c"

#if defined(PDEF_H)

 INT(N,3,       EJ("Size of matrix",       "礭"    ))
 RMAT(A,307,N,N,EJ("Coefficient matrix",   ""        ))
 RVEC(B,307,N,  EJ("Right side vector",    ""            ))
 RMAT(C,307,N,N,EJ("Work matrix",          "Ѥι"    ))
 RVEC(X,307,N,  EJ("Solution vector",      "׻"        ))
 PROC(Solve,    EJ("Solve linear equation","ϢΩ"))

#else

 #include "../pocom.h"
 CHECK_FILE_NAME

 void Solve(void) {
     Int i,j,k;

     Check("A B"); Alloc("C X");
     for (i=0;i<N;i++) for (j=0;j<N;j++) C[i][j]=A[i][j];
     for (i=0;i<N;i++) X[i]=B[i];
     for (k=0;k<N;k++) {
         if (C[k][k]==0) Error("Solve", EJ("Denominator is 0","ʬ줬0"));
         for (j=k+1;j<N;j++) C[k][j]/=C[k][k];
         X[k]/=C[k][k];
         for (i=0;i<N;i++) if (i!=k) {
             for (j=k+1;j<N;j++) C[i][j]-=C[i][k]*C[k][j];
             X[i]-=C[i][k]*X[k];
         }
         Progress("#Solve ",k,N);
     }
 }

#endif
